# -*- coding: utf-8 -*-

#2a) Alcuni dei più semplici motif (pattern) proteici individuano sezioni di 
# catene con lunghezza fissa nelle cui posizioni può essere presente un 
# residuo qualsiasi (indicato con "X") oppure un solo tipo di residuo 
# (indicato dalla lettera di tale amminoacido). Per esempio: PXXAXHF  
# Si scriva una funzione get_dna_pattern(aamotif) che, dato un pattern del
# tipo appena descritto, restituisca un'espressione regolare Python che 
# permetta di individuare una qualsiasi sequenza di dna che, una volta 
# tradotta, dia luogo a una sequenza proteica corrispondente a tale pattern.
#
# Indicazione: per specificare sottostringhe alternative in un pattern si 
# utilizza la notazione del seguente esempio: 
# B(?:UCO|ENE) fa match sia con BUCO che con BENE
#
# Es: get_dna_pattern("FXI")  -> (?:TTC|TTT).{3}(?:ATA|ATC|ATT)


from gencode import aa2dna

def get_dna_pattern(aamotif):
    
    def get_codons(aachar):
        return "(?:"+"|".join(aa2dna[aachar])+")"
    
    return "".join( get_codons(a) if a in aa2dna else ".{3}" for a in aamotif)
