# -*- coding: utf-8 -*-

#4a) Se si desidera modificare geneticamente un codone in modo da ottenere, 
# nella proteina espressa, un diverso residuo in quella posizione, occorre
# sostituire da uno a tre valori delle sue tre basi. Considerato che il 
# codice genetico è degenere, nel caso più generale si possono avere diverse
# possibilità. Si scriva una funzione closest_codon(codon, aatarget) che, dato 
# un codone e un amminoacido da ottenere sostituendolo, restituisca il codone 
# codificante l'amminoacido che sia il più simile possibile al codone passato 
# come argomento. Nel caso ce ne siano più di uno, si restituisca il primo 
# tra essi in ordine lessicgrafico.
#
# Es: closest_codon("CGG", "S")  ->  "AGC"
#     closest_codon("GCA", "S")  ->  "TCA"


from gencode import aa2dna

def closest_codon(codon, aatarget):
    
    def hdist(t):
        return sum(e1 != e2 for e1,e2 in zip(codon, t))
    
    codes = aa2dna[aatarget]
    dists = [hdist(code) for code in codes]
    min_d = min(dists)
    res = (code for code,dist in zip(codes,dists) if dist==min_d)
    return sorted(res)[0]


print closest_codon("CGG", "S")  #->  "ACG"