# -*- coding: utf-8 -*-

#3b) Riferendosi al genoma in NC_045512.gb, si consideri la stringa 
# corrispondente alla traduzione del CDS del gene "S" (che codifica la "spike
# protein" sulla superficie del virus). Si applichi ad essa la funzione 
# sviluppata al punto 3a), per ricercare occorrenze dei seguenti pattern:
# 1) R.{2}[RYK]+  2) G[^G]{1,5}G[^G]{1,3}G
# Si scriva la descrizione standard del risultato sul file uso3.txt .
#
# Indicazione: la sequenza della proteina può essere eventualmente ottenuta
# accedendo a opportuni attributi della SeqFeature corrispondente.


from Bio import SeqIO
from soluzione3 import pattern_placement

in_file, out_file  = 'NC_045512.gb', 'uso3.txt'
mymotifs = [r"R.{2}[RYK]+", r"G[^G]{1,5}G[^G]{1,3}G"]

myrecord = SeqIO.read(in_file, "genbank")

mycdsfeat = filter(lambda x: x.type=="CDS" and "gene" in x.qualifiers
                   and "S" in x.qualifiers["gene"], 
                   myrecord.features)[0]

myseq = mycdsfeat.qualifiers["translation"][0]

with open(out_file,'w') as fout:
    fout.write(str(pattern_placement(myseq, mymotifs)))
