# -*- coding: utf-8 -*-

#4b) Si immagini di voler modificare il genoma riportato in NC_045512.gb.
# In particolare, si desidera verificare l'effetto di una particolare 
# sostituzione amminoacidica sulla Glicina di indice 251 (notazione Python) 
# nella struttura primaria della "spike protein" del virus: in essa 
# si desidera ottenere un residuo di tipo "P" (ovvero: 251 G->P).
# Utilizzando la funzione sviluppata al punto 4a), si stabilisca il valore 
# con cui sostituire il codone corrispondente, e si scriva sul file uso4.txt
# il relativo CDS ingegnerizzato, limitatamente alla porzione dall'indice 750 
# al 762 (escluso).
# Ci si riferisca al file .gb per individuare le posizioni su cui operare.


import Bio.SeqIO as SeqIO
from soluzione4 import closest_codon

in_file, out_file  = 'NC_045512.gb', 'uso4.txt'

g_pos = 251
g_dnapos = g_pos*3

#here, we get the required CDS sequence via the corresponding GenBank feature
cds_record = SeqIO.read(in_file, "genbank")
cds_feat = filter(lambda x: x.type=="CDS" and "gene" in x.qualifiers
                   and "S" in x.qualifiers["gene"], 
                   cds_record.features)[0]
my_dnaseq = str( cds_feat.extract(cds_record.seq) )

g_codon = my_dnaseq[g_dnapos: g_dnapos+3]  # GGT

new_codon = closest_codon(g_codon, "P")    # CCT

res = my_dnaseq[:g_dnapos] + new_codon + my_dnaseq[g_dnapos+3:]

with open(out_file,'w') as fout:
    fout.write(res[750:762])
     